"use strict";
/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.moveToDetachedField = exports.initializeForest = exports.ITreeSubscriptionCursorState = exports.TreeNavigationResult = exports.aboveRootPlaceholder = exports.getDetachedFieldContainingPath = exports.DetachedFieldIndex = exports.isCursor = exports.CursorMarker = exports.inCursorNode = exports.inCursorField = exports.anchorSlot = exports.emptyDelta = exports.offsetDetachId = exports.makeDetachedNodeId = exports.isEmptyFieldChanges = exports.emptyFieldChanges = exports.deltaForRootInitialization = exports.forEachField = exports.forEachNodeInSubtree = exports.forEachNode = exports.compareFieldUpPaths = exports.topDownPath = exports.clonePath = exports.compareUpPaths = exports.getDescendant = exports.SparseNode = exports.setGenericTreeField = exports.makeDetachedFieldIndex = exports.applyDelta = exports.announceDelta = exports.combineVisitors = exports.visitDelta = exports.keyAsDetachedField = exports.detachedFieldAsKey = exports.getMapTreeField = exports.iterateCursorField = exports.mapCursorFields = exports.mapCursorField = exports.getDepth = exports.genericTreeDeleteIfEmpty = exports.getGenericTreeField = exports.genericTreeKeys = exports.castCursorToSynchronous = exports.CursorLocationType = exports.rootField = exports.rootFieldKey = exports.EncodedJsonableTree = exports.AnchorSet = exports.EmptyKey = void 0;
exports.RevertibleStatus = exports.AllowedUpdateType = exports.Compatibility = exports.AdaptedViewSchema = exports.taggedOptAtomId = exports.taggedAtomId = exports.revisionMetadataSourceFromInfo = exports.rebaseChangeOverChanges = exports.rebaseChange = exports.rebaseBranch = exports.mintCommit = exports.SessionIdSchema = exports.tagRollbackInverse = exports.verifyChangeRebaser = exports.noFailure = exports.mapTaggedChange = exports.tagChange = exports.makeAnonChange = exports.RevisionTagCodec = exports.RevisionTagSchema = exports.CommitKind = exports.findCommonAncestor = exports.findAncestor = exports.asChangeAtomId = exports.makeChangeAtomId = exports.areEqualChangeAtomIds = exports.EditBuilder = exports.Multiplicity = exports.storedSchemaDecodeDispatcher = exports.encodeFieldSchema = exports.decodeFieldSchema = exports.MapNodeStoredSchema = exports.ObjectNodeStoredSchema = exports.LeafNodeStoredSchema = exports.schemaFormat = exports.storedEmptyFieldSchema = exports.forbiddenFieldKindIdentifier = exports.schemaDataIsEmpty = exports.TreeStoredSchemaRepository = exports.TreeNodeStoredSchema = exports.ValueSchema = void 0;
var index_js_1 = require("./tree/index.js");
Object.defineProperty(exports, "EmptyKey", { enumerable: true, get: function () { return index_js_1.EmptyKey; } });
Object.defineProperty(exports, "AnchorSet", { enumerable: true, get: function () { return index_js_1.AnchorSet; } });
Object.defineProperty(exports, "EncodedJsonableTree", { enumerable: true, get: function () { return index_js_1.EncodedJsonableTree; } });
Object.defineProperty(exports, "rootFieldKey", { enumerable: true, get: function () { return index_js_1.rootFieldKey; } });
Object.defineProperty(exports, "rootField", { enumerable: true, get: function () { return index_js_1.rootField; } });
Object.defineProperty(exports, "CursorLocationType", { enumerable: true, get: function () { return index_js_1.CursorLocationType; } });
Object.defineProperty(exports, "castCursorToSynchronous", { enumerable: true, get: function () { return index_js_1.castCursorToSynchronous; } });
Object.defineProperty(exports, "genericTreeKeys", { enumerable: true, get: function () { return index_js_1.genericTreeKeys; } });
Object.defineProperty(exports, "getGenericTreeField", { enumerable: true, get: function () { return index_js_1.getGenericTreeField; } });
Object.defineProperty(exports, "genericTreeDeleteIfEmpty", { enumerable: true, get: function () { return index_js_1.genericTreeDeleteIfEmpty; } });
Object.defineProperty(exports, "getDepth", { enumerable: true, get: function () { return index_js_1.getDepth; } });
Object.defineProperty(exports, "mapCursorField", { enumerable: true, get: function () { return index_js_1.mapCursorField; } });
Object.defineProperty(exports, "mapCursorFields", { enumerable: true, get: function () { return index_js_1.mapCursorFields; } });
Object.defineProperty(exports, "iterateCursorField", { enumerable: true, get: function () { return index_js_1.iterateCursorField; } });
Object.defineProperty(exports, "getMapTreeField", { enumerable: true, get: function () { return index_js_1.getMapTreeField; } });
Object.defineProperty(exports, "detachedFieldAsKey", { enumerable: true, get: function () { return index_js_1.detachedFieldAsKey; } });
Object.defineProperty(exports, "keyAsDetachedField", { enumerable: true, get: function () { return index_js_1.keyAsDetachedField; } });
Object.defineProperty(exports, "visitDelta", { enumerable: true, get: function () { return index_js_1.visitDelta; } });
Object.defineProperty(exports, "combineVisitors", { enumerable: true, get: function () { return index_js_1.combineVisitors; } });
Object.defineProperty(exports, "announceDelta", { enumerable: true, get: function () { return index_js_1.announceDelta; } });
Object.defineProperty(exports, "applyDelta", { enumerable: true, get: function () { return index_js_1.applyDelta; } });
Object.defineProperty(exports, "makeDetachedFieldIndex", { enumerable: true, get: function () { return index_js_1.makeDetachedFieldIndex; } });
Object.defineProperty(exports, "setGenericTreeField", { enumerable: true, get: function () { return index_js_1.setGenericTreeField; } });
Object.defineProperty(exports, "SparseNode", { enumerable: true, get: function () { return index_js_1.SparseNode; } });
Object.defineProperty(exports, "getDescendant", { enumerable: true, get: function () { return index_js_1.getDescendant; } });
Object.defineProperty(exports, "compareUpPaths", { enumerable: true, get: function () { return index_js_1.compareUpPaths; } });
Object.defineProperty(exports, "clonePath", { enumerable: true, get: function () { return index_js_1.clonePath; } });
Object.defineProperty(exports, "topDownPath", { enumerable: true, get: function () { return index_js_1.topDownPath; } });
Object.defineProperty(exports, "compareFieldUpPaths", { enumerable: true, get: function () { return index_js_1.compareFieldUpPaths; } });
Object.defineProperty(exports, "forEachNode", { enumerable: true, get: function () { return index_js_1.forEachNode; } });
Object.defineProperty(exports, "forEachNodeInSubtree", { enumerable: true, get: function () { return index_js_1.forEachNodeInSubtree; } });
Object.defineProperty(exports, "forEachField", { enumerable: true, get: function () { return index_js_1.forEachField; } });
Object.defineProperty(exports, "deltaForRootInitialization", { enumerable: true, get: function () { return index_js_1.deltaForRootInitialization; } });
Object.defineProperty(exports, "emptyFieldChanges", { enumerable: true, get: function () { return index_js_1.emptyFieldChanges; } });
Object.defineProperty(exports, "isEmptyFieldChanges", { enumerable: true, get: function () { return index_js_1.isEmptyFieldChanges; } });
Object.defineProperty(exports, "makeDetachedNodeId", { enumerable: true, get: function () { return index_js_1.makeDetachedNodeId; } });
Object.defineProperty(exports, "offsetDetachId", { enumerable: true, get: function () { return index_js_1.offsetDetachId; } });
Object.defineProperty(exports, "emptyDelta", { enumerable: true, get: function () { return index_js_1.emptyDelta; } });
Object.defineProperty(exports, "anchorSlot", { enumerable: true, get: function () { return index_js_1.anchorSlot; } });
Object.defineProperty(exports, "inCursorField", { enumerable: true, get: function () { return index_js_1.inCursorField; } });
Object.defineProperty(exports, "inCursorNode", { enumerable: true, get: function () { return index_js_1.inCursorNode; } });
Object.defineProperty(exports, "CursorMarker", { enumerable: true, get: function () { return index_js_1.CursorMarker; } });
Object.defineProperty(exports, "isCursor", { enumerable: true, get: function () { return index_js_1.isCursor; } });
Object.defineProperty(exports, "DetachedFieldIndex", { enumerable: true, get: function () { return index_js_1.DetachedFieldIndex; } });
Object.defineProperty(exports, "getDetachedFieldContainingPath", { enumerable: true, get: function () { return index_js_1.getDetachedFieldContainingPath; } });
Object.defineProperty(exports, "aboveRootPlaceholder", { enumerable: true, get: function () { return index_js_1.aboveRootPlaceholder; } });
var index_js_2 = require("./forest/index.js");
Object.defineProperty(exports, "TreeNavigationResult", { enumerable: true, get: function () { return index_js_2.TreeNavigationResult; } });
Object.defineProperty(exports, "ITreeSubscriptionCursorState", { enumerable: true, get: function () { return index_js_2.ITreeSubscriptionCursorState; } });
Object.defineProperty(exports, "initializeForest", { enumerable: true, get: function () { return index_js_2.initializeForest; } });
Object.defineProperty(exports, "moveToDetachedField", { enumerable: true, get: function () { return index_js_2.moveToDetachedField; } });
var index_js_3 = require("./schema-stored/index.js");
Object.defineProperty(exports, "ValueSchema", { enumerable: true, get: function () { return index_js_3.ValueSchema; } });
Object.defineProperty(exports, "TreeNodeStoredSchema", { enumerable: true, get: function () { return index_js_3.TreeNodeStoredSchema; } });
Object.defineProperty(exports, "TreeStoredSchemaRepository", { enumerable: true, get: function () { return index_js_3.TreeStoredSchemaRepository; } });
Object.defineProperty(exports, "schemaDataIsEmpty", { enumerable: true, get: function () { return index_js_3.schemaDataIsEmpty; } });
Object.defineProperty(exports, "forbiddenFieldKindIdentifier", { enumerable: true, get: function () { return index_js_3.forbiddenFieldKindIdentifier; } });
Object.defineProperty(exports, "storedEmptyFieldSchema", { enumerable: true, get: function () { return index_js_3.storedEmptyFieldSchema; } });
Object.defineProperty(exports, "schemaFormat", { enumerable: true, get: function () { return index_js_3.schemaFormat; } });
Object.defineProperty(exports, "LeafNodeStoredSchema", { enumerable: true, get: function () { return index_js_3.LeafNodeStoredSchema; } });
Object.defineProperty(exports, "ObjectNodeStoredSchema", { enumerable: true, get: function () { return index_js_3.ObjectNodeStoredSchema; } });
Object.defineProperty(exports, "MapNodeStoredSchema", { enumerable: true, get: function () { return index_js_3.MapNodeStoredSchema; } });
Object.defineProperty(exports, "decodeFieldSchema", { enumerable: true, get: function () { return index_js_3.decodeFieldSchema; } });
Object.defineProperty(exports, "encodeFieldSchema", { enumerable: true, get: function () { return index_js_3.encodeFieldSchema; } });
Object.defineProperty(exports, "storedSchemaDecodeDispatcher", { enumerable: true, get: function () { return index_js_3.storedSchemaDecodeDispatcher; } });
Object.defineProperty(exports, "Multiplicity", { enumerable: true, get: function () { return index_js_3.Multiplicity; } });
var index_js_4 = require("./change-family/index.js");
Object.defineProperty(exports, "EditBuilder", { enumerable: true, get: function () { return index_js_4.EditBuilder; } });
var index_js_5 = require("./rebase/index.js");
Object.defineProperty(exports, "areEqualChangeAtomIds", { enumerable: true, get: function () { return index_js_5.areEqualChangeAtomIds; } });
Object.defineProperty(exports, "makeChangeAtomId", { enumerable: true, get: function () { return index_js_5.makeChangeAtomId; } });
Object.defineProperty(exports, "asChangeAtomId", { enumerable: true, get: function () { return index_js_5.asChangeAtomId; } });
Object.defineProperty(exports, "findAncestor", { enumerable: true, get: function () { return index_js_5.findAncestor; } });
Object.defineProperty(exports, "findCommonAncestor", { enumerable: true, get: function () { return index_js_5.findCommonAncestor; } });
Object.defineProperty(exports, "CommitKind", { enumerable: true, get: function () { return index_js_5.CommitKind; } });
Object.defineProperty(exports, "RevisionTagSchema", { enumerable: true, get: function () { return index_js_5.RevisionTagSchema; } });
Object.defineProperty(exports, "RevisionTagCodec", { enumerable: true, get: function () { return index_js_5.RevisionTagCodec; } });
Object.defineProperty(exports, "makeAnonChange", { enumerable: true, get: function () { return index_js_5.makeAnonChange; } });
Object.defineProperty(exports, "tagChange", { enumerable: true, get: function () { return index_js_5.tagChange; } });
Object.defineProperty(exports, "mapTaggedChange", { enumerable: true, get: function () { return index_js_5.mapTaggedChange; } });
Object.defineProperty(exports, "noFailure", { enumerable: true, get: function () { return index_js_5.noFailure; } });
Object.defineProperty(exports, "verifyChangeRebaser", { enumerable: true, get: function () { return index_js_5.verifyChangeRebaser; } });
Object.defineProperty(exports, "tagRollbackInverse", { enumerable: true, get: function () { return index_js_5.tagRollbackInverse; } });
Object.defineProperty(exports, "SessionIdSchema", { enumerable: true, get: function () { return index_js_5.SessionIdSchema; } });
Object.defineProperty(exports, "mintCommit", { enumerable: true, get: function () { return index_js_5.mintCommit; } });
Object.defineProperty(exports, "rebaseBranch", { enumerable: true, get: function () { return index_js_5.rebaseBranch; } });
Object.defineProperty(exports, "rebaseChange", { enumerable: true, get: function () { return index_js_5.rebaseChange; } });
Object.defineProperty(exports, "rebaseChangeOverChanges", { enumerable: true, get: function () { return index_js_5.rebaseChangeOverChanges; } });
Object.defineProperty(exports, "revisionMetadataSourceFromInfo", { enumerable: true, get: function () { return index_js_5.revisionMetadataSourceFromInfo; } });
Object.defineProperty(exports, "taggedAtomId", { enumerable: true, get: function () { return index_js_5.taggedAtomId; } });
Object.defineProperty(exports, "taggedOptAtomId", { enumerable: true, get: function () { return index_js_5.taggedOptAtomId; } });
var index_js_6 = require("./schema-view/index.js");
Object.defineProperty(exports, "AdaptedViewSchema", { enumerable: true, get: function () { return index_js_6.AdaptedViewSchema; } });
Object.defineProperty(exports, "Compatibility", { enumerable: true, get: function () { return index_js_6.Compatibility; } });
Object.defineProperty(exports, "AllowedUpdateType", { enumerable: true, get: function () { return index_js_6.AllowedUpdateType; } });
var index_js_7 = require("./revertible/index.js");
Object.defineProperty(exports, "RevertibleStatus", { enumerable: true, get: function () { return index_js_7.RevertibleStatus; } });
//# sourceMappingURL=index.js.map