/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import { IIdCompressor, SessionId } from "@fluidframework/id-compressor";
import { IJsonCodec } from "../../codec/index.js";
import { ChangeEncodingContext } from "../change-family/index.js";
import { EncodedRevisionTag, RevisionTag } from "./types.js";
export declare class RevisionTagCodec implements IJsonCodec<RevisionTag, EncodedRevisionTag, EncodedRevisionTag, ChangeEncodingContext> {
    private readonly idCompressor;
    localSessionId: SessionId;
    constructor(idCompressor: IIdCompressor);
    encode(tag: RevisionTag): EncodedRevisionTag;
    decode(tag: EncodedRevisionTag, context: ChangeEncodingContext): RevisionTag;
}
//# sourceMappingURL=revisionTagCodec.d.ts.map