/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import { ITreeCursorSynchronous } from "./cursor.js";
import { DetachedNodeId, FieldChanges, Mark, Root } from "./delta.js";
export declare const emptyDelta: Root<never>;
export declare const emptyFieldChanges: FieldChanges;
export declare function isAttachMark(mark: Mark): boolean;
export declare function isDetachMark(mark: Mark): boolean;
export declare function isReplaceMark(mark: Mark): boolean;
export declare function isEmptyFieldChanges(fieldChanges: FieldChanges): boolean;
export declare function deltaForRootInitialization(content: readonly ITreeCursorSynchronous[]): Root;
export declare function makeDetachedNodeId(major: DetachedNodeId["major"], minor: DetachedNodeId["minor"]): DetachedNodeId;
export declare function offsetDetachId(id: DetachedNodeId, offset: number): DetachedNodeId;
export declare function offsetDetachId(id: DetachedNodeId | undefined, offset: number): DetachedNodeId | undefined;
export declare function areDetachedNodeIdsEqual(a: DetachedNodeId, b: DetachedNodeId): boolean;
//# sourceMappingURL=deltaUtil.d.ts.map