/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import { ReferenceCountedBase } from "../../util/index.js";
import { ChunkedCursor, TreeChunk } from "./chunk.js";
/**
 * General purpose multi-node sequence chunk.
 */
export declare class SequenceChunk extends ReferenceCountedBase implements TreeChunk {
    readonly subChunks: TreeChunk[];
    get topLevelLength(): number;
    /**
     * Create a tree chunk with ref count 1.
     *
     * @param fields - provides exclusive deep ownership of this map to this object (which might mutate it in the future).
     * The caller must have already accounted for this reference to the children in this map (via `referenceAdded`),
     * and any edits to this must update child reference counts.
     * @param value - the value on this node, if any.
     */
    constructor(subChunks: TreeChunk[]);
    clone(): SequenceChunk;
    cursor(): ChunkedCursor;
    protected onUnreferenced(): void;
}
//# sourceMappingURL=sequenceChunk.d.ts.map