/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import { IChannelStorageService } from "@fluidframework/datastore-definitions";
import { IGarbageCollectionData, ISummaryTreeWithStats, ITelemetryContext } from "@fluidframework/runtime-definitions";
import { DetachedFieldIndex } from "../core/index.js";
import { Summarizable, SummaryElementParser, SummaryElementStringifier } from "../shared-tree-core/index.js";
/**
 * Provides methods for summarizing and loading a tree index.
 */
export declare class DetachedFieldIndexSummarizer implements Summarizable {
    private readonly detachedFieldIndex;
    readonly key = "DetachedFieldIndex";
    constructor(detachedFieldIndex: DetachedFieldIndex);
    getAttachSummary(stringify: SummaryElementStringifier, fullTree?: boolean, trackState?: boolean, telemetryContext?: ITelemetryContext): ISummaryTreeWithStats;
    summarize(stringify: SummaryElementStringifier, fullTree?: boolean, trackState?: boolean, telemetryContext?: ITelemetryContext): Promise<ISummaryTreeWithStats>;
    getGCData(fullGC?: boolean): IGarbageCollectionData;
    load(services: IChannelStorageService, parse: SummaryElementParser): Promise<void>;
}
//# sourceMappingURL=detachedFieldIndexSummarizer.d.ts.map