/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import { ICodecOptions, IJsonCodec } from "../../codec/index.js";
import { FieldKey, ITreeCursorSynchronous } from "../../core/index.js";
import { FieldBatchCodec, FieldBatchEncodingContext } from "../chunked-forest/index.js";
import { Format } from "./format.js";
/**
 * Uses field cursors
 */
export type FieldSet = ReadonlyMap<FieldKey, ITreeCursorSynchronous>;
export type ForestCodec = IJsonCodec<FieldSet, Format, Format, FieldBatchEncodingContext>;
export declare function makeForestSummarizerCodec(options: ICodecOptions, fieldBatchCodec: FieldBatchCodec): ForestCodec;
//# sourceMappingURL=codec.d.ts.map