"use strict";
/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FlexFieldKind = exports.CrossFieldTarget = exports.makeModularChangeCodecFamily = exports.ModularEditBuilder = exports.isNeverField = exports.SequenceField = exports.jsonableTreeFromForest = exports.jsonableTreeFromFieldCursor = exports.jsonableTreeFromCursor = exports.cursorForJsonableTreeField = exports.cursorForJsonableTreeNode = exports.stackTreeFieldCursor = exports.prefixFieldPath = exports.prefixPath = exports.stackTreeNodeCursor = exports.makeSchemaCodec = exports.encodeTreeSchema = exports.SchemaSummarizer = exports.buildForest = exports.MemoizedIdRangeAllocator = exports.mapTreeFromCursor = exports.cursorForMapTreeNode = exports.cursorForMapTreeField = exports.ForestSummarizer = exports.isTreeValue = exports.isFluidHandle = exports.assertAllowedValue = exports.allowsValue = exports.getAllowedTypes = exports.getPossibleTypes = exports.normalizeNewFieldContent = exports.cursorsForTypedFieldData = exports.cursorForTypedTreeData = exports.cursorForTypedData = exports.cursorsFromContextualData = exports.cursorFromContextualData = exports.getFieldKind = exports.isContextuallyTypedNodeDataObject = exports.valueSymbol = exports.typeNameSymbol = exports.compileSyntaxTree = exports.comparePipeline = exports.toDownPath = exports.BindingType = exports.indexSymbol = exports.createFlushableBinderOptions = exports.createBinderOptions = exports.createDataBinderInvalidating = exports.createDataBinderDirect = exports.createDataBinderBuffering = void 0;
exports.TreeStatus = exports.getTreeContext = exports.Skip = exports.relevantRemovedRoots = exports.intoDelta = exports.fieldKindConfigurations = exports.fieldKinds = exports.defaultSchemaPolicy = exports.DefaultEditBuilder = exports.DefaultChangeFamily = exports.FieldKinds = exports.nodeKeyTreeIdentifier = exports.nodeKeyFieldKey = exports.NodeKeyIndex = exports.createMockNodeKeyManager = exports.createNodeKeyManager = exports.compareLocalNodeKeys = exports.makeFieldBatchCodec = exports.makeTreeChunker = exports.defaultChunkPolicy = exports.buildChunkedForest = exports.chunkFieldSingle = exports.chunkTree = exports.mapRootChanges = exports.SchemaBuilderInternal = exports.normalizeField = exports.normalizeAllowedTypes = exports.SchemaBuilderBase = exports.intoStoredSchemaCollection = exports.intoStoredSchema = exports.isLazy = exports.TreeNodeSchemaBase = exports.markEager = exports.schemaIsObjectNode = exports.schemaIsMap = exports.schemaIsLeaf = exports.schemaIsFieldNode = exports.FlexObjectNodeSchema = exports.FlexMapNodeSchema = exports.LeafNodeSchema = exports.FlexFieldNodeSchema = exports.ViewSchema = exports.Any = exports.FlexFieldSchema = exports.EncodedModularChangeset = exports.ModularChangeFamily = exports.FieldKindWithEditor = exports.NodeExistenceState = exports.genericFieldKind = exports.allowsRepoSuperset = void 0;
exports.makeMitigatedChangeFamily = exports.EncodedSchemaChange = exports.makeSchemaChangeCodecs = exports.DetachedFieldIndexSummarizer = exports.valueSchemaAllows = exports.TreeCompressionStrategy = exports.treeSchemaFromStoredSchema = exports.flexTreeSlot = exports.assertFlexTreeEntityNotFreed = exports.reservedObjectNodeFieldPropertyNamePrefixes = exports.reservedObjectNodeFieldPropertyNames = exports.FlexTreeEntityKind = exports.flexTreeMarker = exports.ContextSlot = exports.isFlexTreeNode = exports.Context = void 0;
var editableTreeBinder_js_1 = require("./editableTreeBinder.js");
Object.defineProperty(exports, "createDataBinderBuffering", { enumerable: true, get: function () { return editableTreeBinder_js_1.createDataBinderBuffering; } });
Object.defineProperty(exports, "createDataBinderDirect", { enumerable: true, get: function () { return editableTreeBinder_js_1.createDataBinderDirect; } });
Object.defineProperty(exports, "createDataBinderInvalidating", { enumerable: true, get: function () { return editableTreeBinder_js_1.createDataBinderInvalidating; } });
Object.defineProperty(exports, "createBinderOptions", { enumerable: true, get: function () { return editableTreeBinder_js_1.createBinderOptions; } });
Object.defineProperty(exports, "createFlushableBinderOptions", { enumerable: true, get: function () { return editableTreeBinder_js_1.createFlushableBinderOptions; } });
Object.defineProperty(exports, "indexSymbol", { enumerable: true, get: function () { return editableTreeBinder_js_1.indexSymbol; } });
Object.defineProperty(exports, "BindingType", { enumerable: true, get: function () { return editableTreeBinder_js_1.BindingType; } });
Object.defineProperty(exports, "toDownPath", { enumerable: true, get: function () { return editableTreeBinder_js_1.toDownPath; } });
Object.defineProperty(exports, "comparePipeline", { enumerable: true, get: function () { return editableTreeBinder_js_1.comparePipeline; } });
Object.defineProperty(exports, "compileSyntaxTree", { enumerable: true, get: function () { return editableTreeBinder_js_1.compileSyntaxTree; } });
var contextuallyTyped_js_1 = require("./contextuallyTyped.js");
Object.defineProperty(exports, "typeNameSymbol", { enumerable: true, get: function () { return contextuallyTyped_js_1.typeNameSymbol; } });
Object.defineProperty(exports, "valueSymbol", { enumerable: true, get: function () { return contextuallyTyped_js_1.valueSymbol; } });
Object.defineProperty(exports, "isContextuallyTypedNodeDataObject", { enumerable: true, get: function () { return contextuallyTyped_js_1.isContextuallyTypedNodeDataObject; } });
Object.defineProperty(exports, "getFieldKind", { enumerable: true, get: function () { return contextuallyTyped_js_1.getFieldKind; } });
Object.defineProperty(exports, "cursorFromContextualData", { enumerable: true, get: function () { return contextuallyTyped_js_1.cursorFromContextualData; } });
Object.defineProperty(exports, "cursorsFromContextualData", { enumerable: true, get: function () { return contextuallyTyped_js_1.cursorsFromContextualData; } });
Object.defineProperty(exports, "cursorForTypedData", { enumerable: true, get: function () { return contextuallyTyped_js_1.cursorForTypedData; } });
Object.defineProperty(exports, "cursorForTypedTreeData", { enumerable: true, get: function () { return contextuallyTyped_js_1.cursorForTypedTreeData; } });
Object.defineProperty(exports, "cursorsForTypedFieldData", { enumerable: true, get: function () { return contextuallyTyped_js_1.cursorsForTypedFieldData; } });
Object.defineProperty(exports, "normalizeNewFieldContent", { enumerable: true, get: function () { return contextuallyTyped_js_1.normalizeNewFieldContent; } });
Object.defineProperty(exports, "getPossibleTypes", { enumerable: true, get: function () { return contextuallyTyped_js_1.getPossibleTypes; } });
Object.defineProperty(exports, "getAllowedTypes", { enumerable: true, get: function () { return contextuallyTyped_js_1.getAllowedTypes; } });
var valueUtilities_js_1 = require("./valueUtilities.js");
Object.defineProperty(exports, "allowsValue", { enumerable: true, get: function () { return valueUtilities_js_1.allowsValue; } });
Object.defineProperty(exports, "assertAllowedValue", { enumerable: true, get: function () { return valueUtilities_js_1.assertAllowedValue; } });
Object.defineProperty(exports, "isFluidHandle", { enumerable: true, get: function () { return valueUtilities_js_1.isFluidHandle; } });
Object.defineProperty(exports, "isTreeValue", { enumerable: true, get: function () { return valueUtilities_js_1.isTreeValue; } });
var index_js_1 = require("./forest-summary/index.js");
Object.defineProperty(exports, "ForestSummarizer", { enumerable: true, get: function () { return index_js_1.ForestSummarizer; } });
var mapTreeCursor_js_1 = require("./mapTreeCursor.js");
Object.defineProperty(exports, "cursorForMapTreeField", { enumerable: true, get: function () { return mapTreeCursor_js_1.cursorForMapTreeField; } });
Object.defineProperty(exports, "cursorForMapTreeNode", { enumerable: true, get: function () { return mapTreeCursor_js_1.cursorForMapTreeNode; } });
Object.defineProperty(exports, "mapTreeFromCursor", { enumerable: true, get: function () { return mapTreeCursor_js_1.mapTreeFromCursor; } });
var memoizedIdRangeAllocator_js_1 = require("./memoizedIdRangeAllocator.js");
Object.defineProperty(exports, "MemoizedIdRangeAllocator", { enumerable: true, get: function () { return memoizedIdRangeAllocator_js_1.MemoizedIdRangeAllocator; } });
var index_js_2 = require("./object-forest/index.js");
Object.defineProperty(exports, "buildForest", { enumerable: true, get: function () { return index_js_2.buildForest; } });
var index_js_3 = require("./schema-index/index.js");
Object.defineProperty(exports, "SchemaSummarizer", { enumerable: true, get: function () { return index_js_3.SchemaSummarizer; } });
Object.defineProperty(exports, "encodeTreeSchema", { enumerable: true, get: function () { return index_js_3.encodeTreeSchema; } });
Object.defineProperty(exports, "makeSchemaCodec", { enumerable: true, get: function () { return index_js_3.makeSchemaCodec; } });
var treeCursorUtils_js_1 = require("./treeCursorUtils.js");
Object.defineProperty(exports, "stackTreeNodeCursor", { enumerable: true, get: function () { return treeCursorUtils_js_1.stackTreeNodeCursor; } });
Object.defineProperty(exports, "prefixPath", { enumerable: true, get: function () { return treeCursorUtils_js_1.prefixPath; } });
Object.defineProperty(exports, "prefixFieldPath", { enumerable: true, get: function () { return treeCursorUtils_js_1.prefixFieldPath; } });
Object.defineProperty(exports, "stackTreeFieldCursor", { enumerable: true, get: function () { return treeCursorUtils_js_1.stackTreeFieldCursor; } });
var treeTextCursor_js_1 = require("./treeTextCursor.js");
Object.defineProperty(exports, "cursorForJsonableTreeNode", { enumerable: true, get: function () { return treeTextCursor_js_1.cursorForJsonableTreeNode; } });
Object.defineProperty(exports, "cursorForJsonableTreeField", { enumerable: true, get: function () { return treeTextCursor_js_1.cursorForJsonableTreeField; } });
Object.defineProperty(exports, "jsonableTreeFromCursor", { enumerable: true, get: function () { return treeTextCursor_js_1.jsonableTreeFromCursor; } });
Object.defineProperty(exports, "jsonableTreeFromFieldCursor", { enumerable: true, get: function () { return treeTextCursor_js_1.jsonableTreeFromFieldCursor; } });
Object.defineProperty(exports, "jsonableTreeFromForest", { enumerable: true, get: function () { return treeTextCursor_js_1.jsonableTreeFromForest; } });
// Split this up into separate import and export for compatibility with API-Extractor.
const SequenceField = __importStar(require("./sequence-field/index.js"));
exports.SequenceField = SequenceField;
var index_js_4 = require("./modular-schema/index.js");
Object.defineProperty(exports, "isNeverField", { enumerable: true, get: function () { return index_js_4.isNeverField; } });
Object.defineProperty(exports, "ModularEditBuilder", { enumerable: true, get: function () { return index_js_4.ModularEditBuilder; } });
Object.defineProperty(exports, "makeModularChangeCodecFamily", { enumerable: true, get: function () { return index_js_4.makeModularChangeCodecFamily; } });
Object.defineProperty(exports, "CrossFieldTarget", { enumerable: true, get: function () { return index_js_4.CrossFieldTarget; } });
Object.defineProperty(exports, "FlexFieldKind", { enumerable: true, get: function () { return index_js_4.FlexFieldKind; } });
Object.defineProperty(exports, "allowsRepoSuperset", { enumerable: true, get: function () { return index_js_4.allowsRepoSuperset; } });
Object.defineProperty(exports, "genericFieldKind", { enumerable: true, get: function () { return index_js_4.genericFieldKind; } });
Object.defineProperty(exports, "NodeExistenceState", { enumerable: true, get: function () { return index_js_4.NodeExistenceState; } });
Object.defineProperty(exports, "FieldKindWithEditor", { enumerable: true, get: function () { return index_js_4.FieldKindWithEditor; } });
Object.defineProperty(exports, "ModularChangeFamily", { enumerable: true, get: function () { return index_js_4.ModularChangeFamily; } });
Object.defineProperty(exports, "EncodedModularChangeset", { enumerable: true, get: function () { return index_js_4.EncodedModularChangeset; } });
var index_js_5 = require("./typed-schema/index.js");
Object.defineProperty(exports, "FlexFieldSchema", { enumerable: true, get: function () { return index_js_5.FlexFieldSchema; } });
Object.defineProperty(exports, "Any", { enumerable: true, get: function () { return index_js_5.Any; } });
Object.defineProperty(exports, "ViewSchema", { enumerable: true, get: function () { return index_js_5.ViewSchema; } });
Object.defineProperty(exports, "FlexFieldNodeSchema", { enumerable: true, get: function () { return index_js_5.FlexFieldNodeSchema; } });
Object.defineProperty(exports, "LeafNodeSchema", { enumerable: true, get: function () { return index_js_5.LeafNodeSchema; } });
Object.defineProperty(exports, "FlexMapNodeSchema", { enumerable: true, get: function () { return index_js_5.FlexMapNodeSchema; } });
Object.defineProperty(exports, "FlexObjectNodeSchema", { enumerable: true, get: function () { return index_js_5.FlexObjectNodeSchema; } });
Object.defineProperty(exports, "schemaIsFieldNode", { enumerable: true, get: function () { return index_js_5.schemaIsFieldNode; } });
Object.defineProperty(exports, "schemaIsLeaf", { enumerable: true, get: function () { return index_js_5.schemaIsLeaf; } });
Object.defineProperty(exports, "schemaIsMap", { enumerable: true, get: function () { return index_js_5.schemaIsMap; } });
Object.defineProperty(exports, "schemaIsObjectNode", { enumerable: true, get: function () { return index_js_5.schemaIsObjectNode; } });
Object.defineProperty(exports, "markEager", { enumerable: true, get: function () { return index_js_5.markEager; } });
Object.defineProperty(exports, "TreeNodeSchemaBase", { enumerable: true, get: function () { return index_js_5.TreeNodeSchemaBase; } });
Object.defineProperty(exports, "isLazy", { enumerable: true, get: function () { return index_js_5.isLazy; } });
Object.defineProperty(exports, "intoStoredSchema", { enumerable: true, get: function () { return index_js_5.intoStoredSchema; } });
Object.defineProperty(exports, "intoStoredSchemaCollection", { enumerable: true, get: function () { return index_js_5.intoStoredSchemaCollection; } });
var schemaBuilderBase_js_1 = require("./schemaBuilderBase.js");
Object.defineProperty(exports, "SchemaBuilderBase", { enumerable: true, get: function () { return schemaBuilderBase_js_1.SchemaBuilderBase; } });
Object.defineProperty(exports, "normalizeAllowedTypes", { enumerable: true, get: function () { return schemaBuilderBase_js_1.normalizeAllowedTypes; } });
Object.defineProperty(exports, "normalizeField", { enumerable: true, get: function () { return schemaBuilderBase_js_1.normalizeField; } });
var schemaBuilder_js_1 = require("./schemaBuilder.js");
Object.defineProperty(exports, "SchemaBuilderInternal", { enumerable: true, get: function () { return schemaBuilder_js_1.SchemaBuilderInternal; } });
var deltaUtils_js_1 = require("./deltaUtils.js");
Object.defineProperty(exports, "mapRootChanges", { enumerable: true, get: function () { return deltaUtils_js_1.mapRootChanges; } });
var index_js_6 = require("./chunked-forest/index.js");
Object.defineProperty(exports, "chunkTree", { enumerable: true, get: function () { return index_js_6.chunkTree; } });
Object.defineProperty(exports, "chunkFieldSingle", { enumerable: true, get: function () { return index_js_6.chunkFieldSingle; } });
Object.defineProperty(exports, "buildChunkedForest", { enumerable: true, get: function () { return index_js_6.buildChunkedForest; } });
Object.defineProperty(exports, "defaultChunkPolicy", { enumerable: true, get: function () { return index_js_6.defaultChunkPolicy; } });
Object.defineProperty(exports, "makeTreeChunker", { enumerable: true, get: function () { return index_js_6.makeTreeChunker; } });
Object.defineProperty(exports, "makeFieldBatchCodec", { enumerable: true, get: function () { return index_js_6.makeFieldBatchCodec; } });
var index_js_7 = require("./node-key/index.js");
Object.defineProperty(exports, "compareLocalNodeKeys", { enumerable: true, get: function () { return index_js_7.compareLocalNodeKeys; } });
Object.defineProperty(exports, "createNodeKeyManager", { enumerable: true, get: function () { return index_js_7.createNodeKeyManager; } });
Object.defineProperty(exports, "createMockNodeKeyManager", { enumerable: true, get: function () { return index_js_7.createMockNodeKeyManager; } });
Object.defineProperty(exports, "NodeKeyIndex", { enumerable: true, get: function () { return index_js_7.NodeKeyIndex; } });
Object.defineProperty(exports, "nodeKeyFieldKey", { enumerable: true, get: function () { return index_js_7.nodeKeyFieldKey; } });
Object.defineProperty(exports, "nodeKeyTreeIdentifier", { enumerable: true, get: function () { return index_js_7.nodeKeyTreeIdentifier; } });
var index_js_8 = require("./default-schema/index.js");
Object.defineProperty(exports, "FieldKinds", { enumerable: true, get: function () { return index_js_8.FieldKinds; } });
Object.defineProperty(exports, "DefaultChangeFamily", { enumerable: true, get: function () { return index_js_8.DefaultChangeFamily; } });
Object.defineProperty(exports, "DefaultEditBuilder", { enumerable: true, get: function () { return index_js_8.DefaultEditBuilder; } });
Object.defineProperty(exports, "defaultSchemaPolicy", { enumerable: true, get: function () { return index_js_8.defaultSchemaPolicy; } });
Object.defineProperty(exports, "fieldKinds", { enumerable: true, get: function () { return index_js_8.fieldKinds; } });
Object.defineProperty(exports, "fieldKindConfigurations", { enumerable: true, get: function () { return index_js_8.fieldKindConfigurations; } });
Object.defineProperty(exports, "intoDelta", { enumerable: true, get: function () { return index_js_8.intoDelta; } });
Object.defineProperty(exports, "relevantRemovedRoots", { enumerable: true, get: function () { return index_js_8.relevantRemovedRoots; } });
var index_js_9 = require("./flex-tree/index.js");
Object.defineProperty(exports, "Skip", { enumerable: true, get: function () { return index_js_9.Skip; } });
Object.defineProperty(exports, "getTreeContext", { enumerable: true, get: function () { return index_js_9.getTreeContext; } });
Object.defineProperty(exports, "TreeStatus", { enumerable: true, get: function () { return index_js_9.TreeStatus; } });
Object.defineProperty(exports, "Context", { enumerable: true, get: function () { return index_js_9.Context; } });
Object.defineProperty(exports, "isFlexTreeNode", { enumerable: true, get: function () { return index_js_9.isFlexTreeNode; } });
Object.defineProperty(exports, "ContextSlot", { enumerable: true, get: function () { return index_js_9.ContextSlot; } });
Object.defineProperty(exports, "flexTreeMarker", { enumerable: true, get: function () { return index_js_9.flexTreeMarker; } });
Object.defineProperty(exports, "FlexTreeEntityKind", { enumerable: true, get: function () { return index_js_9.FlexTreeEntityKind; } });
Object.defineProperty(exports, "reservedObjectNodeFieldPropertyNames", { enumerable: true, get: function () { return index_js_9.reservedObjectNodeFieldPropertyNames; } });
Object.defineProperty(exports, "reservedObjectNodeFieldPropertyNamePrefixes", { enumerable: true, get: function () { return index_js_9.reservedObjectNodeFieldPropertyNamePrefixes; } });
Object.defineProperty(exports, "assertFlexTreeEntityNotFreed", { enumerable: true, get: function () { return index_js_9.assertFlexTreeEntityNotFreed; } });
Object.defineProperty(exports, "flexTreeSlot", { enumerable: true, get: function () { return index_js_9.flexTreeSlot; } });
var storedToViewSchema_js_1 = require("./storedToViewSchema.js");
Object.defineProperty(exports, "treeSchemaFromStoredSchema", { enumerable: true, get: function () { return storedToViewSchema_js_1.treeSchemaFromStoredSchema; } });
var treeCompressionUtils_js_1 = require("./treeCompressionUtils.js");
Object.defineProperty(exports, "TreeCompressionStrategy", { enumerable: true, get: function () { return treeCompressionUtils_js_1.TreeCompressionStrategy; } });
var valueUtilities_js_2 = require("./valueUtilities.js");
Object.defineProperty(exports, "valueSchemaAllows", { enumerable: true, get: function () { return valueUtilities_js_2.valueSchemaAllows; } });
var detachedFieldIndexSummarizer_js_1 = require("./detachedFieldIndexSummarizer.js");
Object.defineProperty(exports, "DetachedFieldIndexSummarizer", { enumerable: true, get: function () { return detachedFieldIndexSummarizer_js_1.DetachedFieldIndexSummarizer; } });
var index_js_10 = require("./schema-edits/index.js");
Object.defineProperty(exports, "makeSchemaChangeCodecs", { enumerable: true, get: function () { return index_js_10.makeSchemaChangeCodecs; } });
Object.defineProperty(exports, "EncodedSchemaChange", { enumerable: true, get: function () { return index_js_10.EncodedSchemaChange; } });
var mitigatedChangeFamily_js_1 = require("./mitigatedChangeFamily.js");
Object.defineProperty(exports, "makeMitigatedChangeFamily", { enumerable: true, get: function () { return mitigatedChangeFamily_js_1.makeMitigatedChangeFamily; } });
//# sourceMappingURL=index.js.map