"use strict";
/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.makeModularChangeCodecFamily = exports.relevantRemovedRoots = exports.intoDelta = exports.rebaseRevisionMetadataFromInfo = exports.ModularEditBuilder = exports.ModularChangeFamily = exports.genericFieldKind = exports.genericChangeHandler = exports.convertGenericChange = exports.NodeExistenceState = exports.referenceFreeFieldChangeRebaser = exports.getIntention = exports.FieldKindWithEditor = exports.FlexFieldKind = exports.EncodedNodeChangeset = exports.EncodedModularChangeset = exports.EncodedRevisionInfo = exports.EncodedChangeAtomId = exports.ChangesetLocalIdSchema = exports.setInCrossFieldMap = exports.CrossFieldTarget = exports.addCrossFieldQuery = exports.isNeverTree = exports.isNeverField = exports.allowsTreeSuperset = exports.allowsFieldSuperset = exports.allowsTreeSchemaIdentifierSuperset = exports.allowsRepoSuperset = void 0;
var comparison_js_1 = require("./comparison.js");
Object.defineProperty(exports, "allowsRepoSuperset", { enumerable: true, get: function () { return comparison_js_1.allowsRepoSuperset; } });
Object.defineProperty(exports, "allowsTreeSchemaIdentifierSuperset", { enumerable: true, get: function () { return comparison_js_1.allowsTreeSchemaIdentifierSuperset; } });
Object.defineProperty(exports, "allowsFieldSuperset", { enumerable: true, get: function () { return comparison_js_1.allowsFieldSuperset; } });
Object.defineProperty(exports, "allowsTreeSuperset", { enumerable: true, get: function () { return comparison_js_1.allowsTreeSuperset; } });
var isNeverTree_js_1 = require("./isNeverTree.js");
Object.defineProperty(exports, "isNeverField", { enumerable: true, get: function () { return isNeverTree_js_1.isNeverField; } });
Object.defineProperty(exports, "isNeverTree", { enumerable: true, get: function () { return isNeverTree_js_1.isNeverTree; } });
var crossFieldQueries_js_1 = require("./crossFieldQueries.js");
Object.defineProperty(exports, "addCrossFieldQuery", { enumerable: true, get: function () { return crossFieldQueries_js_1.addCrossFieldQuery; } });
Object.defineProperty(exports, "CrossFieldTarget", { enumerable: true, get: function () { return crossFieldQueries_js_1.CrossFieldTarget; } });
Object.defineProperty(exports, "setInCrossFieldMap", { enumerable: true, get: function () { return crossFieldQueries_js_1.setInCrossFieldMap; } });
var modularChangeFormat_js_1 = require("./modularChangeFormat.js");
Object.defineProperty(exports, "ChangesetLocalIdSchema", { enumerable: true, get: function () { return modularChangeFormat_js_1.ChangesetLocalIdSchema; } });
Object.defineProperty(exports, "EncodedChangeAtomId", { enumerable: true, get: function () { return modularChangeFormat_js_1.EncodedChangeAtomId; } });
Object.defineProperty(exports, "EncodedRevisionInfo", { enumerable: true, get: function () { return modularChangeFormat_js_1.EncodedRevisionInfo; } });
Object.defineProperty(exports, "EncodedModularChangeset", { enumerable: true, get: function () { return modularChangeFormat_js_1.EncodedModularChangeset; } });
Object.defineProperty(exports, "EncodedNodeChangeset", { enumerable: true, get: function () { return modularChangeFormat_js_1.EncodedNodeChangeset; } });
var fieldKind_js_1 = require("./fieldKind.js");
Object.defineProperty(exports, "FlexFieldKind", { enumerable: true, get: function () { return fieldKind_js_1.FlexFieldKind; } });
var fieldKindWithEditor_js_1 = require("./fieldKindWithEditor.js");
Object.defineProperty(exports, "FieldKindWithEditor", { enumerable: true, get: function () { return fieldKindWithEditor_js_1.FieldKindWithEditor; } });
var fieldChangeHandler_js_1 = require("./fieldChangeHandler.js");
Object.defineProperty(exports, "getIntention", { enumerable: true, get: function () { return fieldChangeHandler_js_1.getIntention; } });
Object.defineProperty(exports, "referenceFreeFieldChangeRebaser", { enumerable: true, get: function () { return fieldChangeHandler_js_1.referenceFreeFieldChangeRebaser; } });
Object.defineProperty(exports, "NodeExistenceState", { enumerable: true, get: function () { return fieldChangeHandler_js_1.NodeExistenceState; } });
var genericFieldKind_js_1 = require("./genericFieldKind.js");
Object.defineProperty(exports, "convertGenericChange", { enumerable: true, get: function () { return genericFieldKind_js_1.convertGenericChange; } });
Object.defineProperty(exports, "genericChangeHandler", { enumerable: true, get: function () { return genericFieldKind_js_1.genericChangeHandler; } });
Object.defineProperty(exports, "genericFieldKind", { enumerable: true, get: function () { return genericFieldKind_js_1.genericFieldKind; } });
var modularChangeFamily_js_1 = require("./modularChangeFamily.js");
Object.defineProperty(exports, "ModularChangeFamily", { enumerable: true, get: function () { return modularChangeFamily_js_1.ModularChangeFamily; } });
Object.defineProperty(exports, "ModularEditBuilder", { enumerable: true, get: function () { return modularChangeFamily_js_1.ModularEditBuilder; } });
Object.defineProperty(exports, "rebaseRevisionMetadataFromInfo", { enumerable: true, get: function () { return modularChangeFamily_js_1.rebaseRevisionMetadataFromInfo; } });
Object.defineProperty(exports, "intoDelta", { enumerable: true, get: function () { return modularChangeFamily_js_1.intoDelta; } });
Object.defineProperty(exports, "relevantRemovedRoots", { enumerable: true, get: function () { return modularChangeFamily_js_1.relevantRemovedRoots; } });
var modularChangeCodecs_js_1 = require("./modularChangeCodecs.js");
Object.defineProperty(exports, "makeModularChangeCodecFamily", { enumerable: true, get: function () { return modularChangeCodecs_js_1.makeModularChangeCodecFamily; } });
//# sourceMappingURL=index.js.map