/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * Utilities for manipulating types.
 */
/**
 * Convert a object type into the type of a ReadonlyMap from field name to value.
 */
export type ObjectToMap<ObjectMap, MapKey extends number | string, MapValue> = ReadonlyMap<MapKey, MapValue> & {
    get<TKey extends keyof ObjectMap>(key: TKey): ObjectMap[TKey];
};
export declare function objectToMapTyped<ObjectMap extends Record<MapKey, MapValue>, MapKey extends string, MapValue>(objectMap: ObjectMap): ObjectToMap<ObjectMap, MapKey, MapValue>;
//# sourceMappingURL=typeUtils.d.ts.map