"use strict";
/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.FlexObjectNodeSchema = exports.FlexMapNodeSchema = exports.LeafNodeSchema = exports.FlexFieldNodeSchema = exports.TreeNodeSchemaBase = exports.TreeStatus = exports.nodeKeyFieldKey = exports.cursorForTypedTreeData = exports.Any = exports.FlexFieldSchema = exports.cursorFromContextualData = exports.FieldKinds = exports.stackTreeNodeCursor = exports.cursorForJsonableTreeNode = exports.prefixFieldPath = exports.prefixPath = exports.compareLocalNodeKeys = exports.jsonableTreeFromCursor = exports.defaultSchemaPolicy = exports.isContextuallyTypedNodeDataObject = exports.valueSymbol = exports.typeNameSymbol = exports.isNeverField = exports.FlexFieldKind = exports.leaf = exports.createEmitter = exports.disposeSymbol = exports.oneFromSet = exports.TransactionResult = exports.fail = exports.brand = exports.extractFromOpaque = exports.Multiplicity = exports.LeafNodeStoredSchema = exports.MapNodeStoredSchema = exports.ObjectNodeStoredSchema = exports.forbiddenFieldKindIdentifier = exports.RevertibleStatus = exports.CommitKind = exports.AllowedUpdateType = exports.anchorSlot = exports.TreeNodeStoredSchema = exports.ValueSchema = exports.ITreeSubscriptionCursorState = exports.TreeNavigationResult = exports.CursorLocationType = exports.rootField = exports.rootFieldKey = exports.AnchorSet = exports.EmptyKey = void 0;
exports.FlexTreeEntityKind = exports.flexTreeMarker = exports.ErasedType = exports.BrandedType = exports.typeboxValidator = exports.noopValidator = exports.configuredSharedTree = exports.SharedTree = exports.test_RecursiveObjectPojoMode = exports.test_RecursiveObject_base = exports.test_RecursiveObject = exports.typedObjectValues = exports.singletonSchema = exports.enumFromStrings = exports.adaptEnum = exports.SchemaFactoryRecursive = exports.NodeKind = exports.FieldSchema = exports.FieldKind = exports.type = exports.SchemaFactory = exports.TreeConfiguration = exports.TreeNode = exports.IterableTreeArrayContent = exports.TreeArrayNode = exports.Tree = exports.SharedTreeFormatVersion = exports.buildTreeConfiguration = exports.ForestType = exports.SharedTreeFactory = exports.runSynchronous = exports.reservedObjectNodeFieldPropertyNamePrefixes = exports.reservedObjectNodeFieldPropertyNames = exports.stackTreeFieldCursor = exports.encodeTreeSchema = exports.treeSchemaFromStoredSchema = exports.TreeCompressionStrategy = exports.schemaIsObjectNode = exports.schemaIsMap = exports.schemaIsLeaf = exports.schemaIsFieldNode = exports.SchemaBuilderBase = void 0;
var index_js_1 = require("./core/index.js");
Object.defineProperty(exports, "EmptyKey", { enumerable: true, get: function () { return index_js_1.EmptyKey; } });
Object.defineProperty(exports, "AnchorSet", { enumerable: true, get: function () { return index_js_1.AnchorSet; } });
Object.defineProperty(exports, "rootFieldKey", { enumerable: true, get: function () { return index_js_1.rootFieldKey; } });
Object.defineProperty(exports, "rootField", { enumerable: true, get: function () { return index_js_1.rootField; } });
Object.defineProperty(exports, "CursorLocationType", { enumerable: true, get: function () { return index_js_1.CursorLocationType; } });
Object.defineProperty(exports, "TreeNavigationResult", { enumerable: true, get: function () { return index_js_1.TreeNavigationResult; } });
Object.defineProperty(exports, "ITreeSubscriptionCursorState", { enumerable: true, get: function () { return index_js_1.ITreeSubscriptionCursorState; } });
Object.defineProperty(exports, "ValueSchema", { enumerable: true, get: function () { return index_js_1.ValueSchema; } });
Object.defineProperty(exports, "TreeNodeStoredSchema", { enumerable: true, get: function () { return index_js_1.TreeNodeStoredSchema; } });
Object.defineProperty(exports, "anchorSlot", { enumerable: true, get: function () { return index_js_1.anchorSlot; } });
Object.defineProperty(exports, "AllowedUpdateType", { enumerable: true, get: function () { return index_js_1.AllowedUpdateType; } });
Object.defineProperty(exports, "CommitKind", { enumerable: true, get: function () { return index_js_1.CommitKind; } });
Object.defineProperty(exports, "RevertibleStatus", { enumerable: true, get: function () { return index_js_1.RevertibleStatus; } });
Object.defineProperty(exports, "forbiddenFieldKindIdentifier", { enumerable: true, get: function () { return index_js_1.forbiddenFieldKindIdentifier; } });
Object.defineProperty(exports, "ObjectNodeStoredSchema", { enumerable: true, get: function () { return index_js_1.ObjectNodeStoredSchema; } });
Object.defineProperty(exports, "MapNodeStoredSchema", { enumerable: true, get: function () { return index_js_1.MapNodeStoredSchema; } });
Object.defineProperty(exports, "LeafNodeStoredSchema", { enumerable: true, get: function () { return index_js_1.LeafNodeStoredSchema; } });
Object.defineProperty(exports, "Multiplicity", { enumerable: true, get: function () { return index_js_1.Multiplicity; } });
var index_js_2 = require("./util/index.js");
Object.defineProperty(exports, "extractFromOpaque", { enumerable: true, get: function () { return index_js_2.extractFromOpaque; } });
Object.defineProperty(exports, "brand", { enumerable: true, get: function () { return index_js_2.brand; } });
Object.defineProperty(exports, "fail", { enumerable: true, get: function () { return index_js_2.fail; } });
Object.defineProperty(exports, "TransactionResult", { enumerable: true, get: function () { return index_js_2.TransactionResult; } });
Object.defineProperty(exports, "oneFromSet", { enumerable: true, get: function () { return index_js_2.oneFromSet; } });
Object.defineProperty(exports, "disposeSymbol", { enumerable: true, get: function () { return index_js_2.disposeSymbol; } });
var index_js_3 = require("./events/index.js");
Object.defineProperty(exports, "createEmitter", { enumerable: true, get: function () { return index_js_3.createEmitter; } });
var index_js_4 = require("./domains/index.js");
Object.defineProperty(exports, "leaf", { enumerable: true, get: function () { return index_js_4.leaf; } });
var index_js_5 = require("./feature-libraries/index.js");
Object.defineProperty(exports, "FlexFieldKind", { enumerable: true, get: function () { return index_js_5.FlexFieldKind; } });
Object.defineProperty(exports, "isNeverField", { enumerable: true, get: function () { return index_js_5.isNeverField; } });
Object.defineProperty(exports, "typeNameSymbol", { enumerable: true, get: function () { return index_js_5.typeNameSymbol; } });
Object.defineProperty(exports, "valueSymbol", { enumerable: true, get: function () { return index_js_5.valueSymbol; } });
Object.defineProperty(exports, "isContextuallyTypedNodeDataObject", { enumerable: true, get: function () { return index_js_5.isContextuallyTypedNodeDataObject; } });
Object.defineProperty(exports, "defaultSchemaPolicy", { enumerable: true, get: function () { return index_js_5.defaultSchemaPolicy; } });
Object.defineProperty(exports, "jsonableTreeFromCursor", { enumerable: true, get: function () { return index_js_5.jsonableTreeFromCursor; } });
Object.defineProperty(exports, "compareLocalNodeKeys", { enumerable: true, get: function () { return index_js_5.compareLocalNodeKeys; } });
Object.defineProperty(exports, "prefixPath", { enumerable: true, get: function () { return index_js_5.prefixPath; } });
Object.defineProperty(exports, "prefixFieldPath", { enumerable: true, get: function () { return index_js_5.prefixFieldPath; } });
Object.defineProperty(exports, "cursorForJsonableTreeNode", { enumerable: true, get: function () { return index_js_5.cursorForJsonableTreeNode; } });
Object.defineProperty(exports, "stackTreeNodeCursor", { enumerable: true, get: function () { return index_js_5.stackTreeNodeCursor; } });
Object.defineProperty(exports, "FieldKinds", { enumerable: true, get: function () { return index_js_5.FieldKinds; } });
Object.defineProperty(exports, "cursorFromContextualData", { enumerable: true, get: function () { return index_js_5.cursorFromContextualData; } });
Object.defineProperty(exports, "FlexFieldSchema", { enumerable: true, get: function () { return index_js_5.FlexFieldSchema; } });
Object.defineProperty(exports, "Any", { enumerable: true, get: function () { return index_js_5.Any; } });
Object.defineProperty(exports, "cursorForTypedTreeData", { enumerable: true, get: function () { return index_js_5.cursorForTypedTreeData; } });
Object.defineProperty(exports, "nodeKeyFieldKey", { enumerable: true, get: function () { return index_js_5.nodeKeyFieldKey; } });
Object.defineProperty(exports, "TreeStatus", { enumerable: true, get: function () { return index_js_5.TreeStatus; } });
Object.defineProperty(exports, "TreeNodeSchemaBase", { enumerable: true, get: function () { return index_js_5.TreeNodeSchemaBase; } });
Object.defineProperty(exports, "FlexFieldNodeSchema", { enumerable: true, get: function () { return index_js_5.FlexFieldNodeSchema; } });
Object.defineProperty(exports, "LeafNodeSchema", { enumerable: true, get: function () { return index_js_5.LeafNodeSchema; } });
Object.defineProperty(exports, "FlexMapNodeSchema", { enumerable: true, get: function () { return index_js_5.FlexMapNodeSchema; } });
Object.defineProperty(exports, "FlexObjectNodeSchema", { enumerable: true, get: function () { return index_js_5.FlexObjectNodeSchema; } });
Object.defineProperty(exports, "SchemaBuilderBase", { enumerable: true, get: function () { return index_js_5.SchemaBuilderBase; } });
Object.defineProperty(exports, "schemaIsFieldNode", { enumerable: true, get: function () { return index_js_5.schemaIsFieldNode; } });
Object.defineProperty(exports, "schemaIsLeaf", { enumerable: true, get: function () { return index_js_5.schemaIsLeaf; } });
Object.defineProperty(exports, "schemaIsMap", { enumerable: true, get: function () { return index_js_5.schemaIsMap; } });
Object.defineProperty(exports, "schemaIsObjectNode", { enumerable: true, get: function () { return index_js_5.schemaIsObjectNode; } });
Object.defineProperty(exports, "TreeCompressionStrategy", { enumerable: true, get: function () { return index_js_5.TreeCompressionStrategy; } });
Object.defineProperty(exports, "treeSchemaFromStoredSchema", { enumerable: true, get: function () { return index_js_5.treeSchemaFromStoredSchema; } });
Object.defineProperty(exports, "encodeTreeSchema", { enumerable: true, get: function () { return index_js_5.encodeTreeSchema; } });
Object.defineProperty(exports, "stackTreeFieldCursor", { enumerable: true, get: function () { return index_js_5.stackTreeFieldCursor; } });
Object.defineProperty(exports, "reservedObjectNodeFieldPropertyNames", { enumerable: true, get: function () { return index_js_5.reservedObjectNodeFieldPropertyNames; } });
Object.defineProperty(exports, "reservedObjectNodeFieldPropertyNamePrefixes", { enumerable: true, get: function () { return index_js_5.reservedObjectNodeFieldPropertyNamePrefixes; } });
var index_js_6 = require("./shared-tree/index.js");
Object.defineProperty(exports, "runSynchronous", { enumerable: true, get: function () { return index_js_6.runSynchronous; } });
Object.defineProperty(exports, "SharedTreeFactory", { enumerable: true, get: function () { return index_js_6.SharedTreeFactory; } });
Object.defineProperty(exports, "ForestType", { enumerable: true, get: function () { return index_js_6.ForestType; } });
Object.defineProperty(exports, "buildTreeConfiguration", { enumerable: true, get: function () { return index_js_6.buildTreeConfiguration; } });
Object.defineProperty(exports, "SharedTreeFormatVersion", { enumerable: true, get: function () { return index_js_6.SharedTreeFormatVersion; } });
Object.defineProperty(exports, "Tree", { enumerable: true, get: function () { return index_js_6.Tree; } });
var index_js_7 = require("./simple-tree/index.js");
Object.defineProperty(exports, "TreeArrayNode", { enumerable: true, get: function () { return index_js_7.TreeArrayNode; } });
Object.defineProperty(exports, "IterableTreeArrayContent", { enumerable: true, get: function () { return index_js_7.IterableTreeArrayContent; } });
Object.defineProperty(exports, "TreeNode", { enumerable: true, get: function () { return index_js_7.TreeNode; } });
Object.defineProperty(exports, "TreeConfiguration", { enumerable: true, get: function () { return index_js_7.TreeConfiguration; } });
Object.defineProperty(exports, "SchemaFactory", { enumerable: true, get: function () { return index_js_7.SchemaFactory; } });
Object.defineProperty(exports, "type", { enumerable: true, get: function () { return index_js_7.type; } });
Object.defineProperty(exports, "FieldKind", { enumerable: true, get: function () { return index_js_7.FieldKind; } });
Object.defineProperty(exports, "FieldSchema", { enumerable: true, get: function () { return index_js_7.FieldSchema; } });
Object.defineProperty(exports, "NodeKind", { enumerable: true, get: function () { return index_js_7.NodeKind; } });
// experimental @beta APIs:
Object.defineProperty(exports, "SchemaFactoryRecursive", { enumerable: true, get: function () { return index_js_7.SchemaFactoryRecursive; } });
// experimental @internal APIs:
Object.defineProperty(exports, "adaptEnum", { enumerable: true, get: function () { return index_js_7.adaptEnum; } });
Object.defineProperty(exports, "enumFromStrings", { enumerable: true, get: function () { return index_js_7.enumFromStrings; } });
Object.defineProperty(exports, "singletonSchema", { enumerable: true, get: function () { return index_js_7.singletonSchema; } });
Object.defineProperty(exports, "typedObjectValues", { enumerable: true, get: function () { return index_js_7.typedObjectValues; } });
// test recursive schema for checking that d.ts files handles schema correctly
Object.defineProperty(exports, "test_RecursiveObject", { enumerable: true, get: function () { return index_js_7.test_RecursiveObject; } });
Object.defineProperty(exports, "test_RecursiveObject_base", { enumerable: true, get: function () { return index_js_7.test_RecursiveObject_base; } });
Object.defineProperty(exports, "test_RecursiveObjectPojoMode", { enumerable: true, get: function () { return index_js_7.test_RecursiveObjectPojoMode; } });
var treeFactory_js_1 = require("./treeFactory.js");
Object.defineProperty(exports, "SharedTree", { enumerable: true, get: function () { return treeFactory_js_1.SharedTree; } });
Object.defineProperty(exports, "configuredSharedTree", { enumerable: true, get: function () { return treeFactory_js_1.configuredSharedTree; } });
var index_js_8 = require("./codec/index.js");
Object.defineProperty(exports, "noopValidator", { enumerable: true, get: function () { return index_js_8.noopValidator; } });
var index_js_9 = require("./external-utilities/index.js");
Object.defineProperty(exports, "typeboxValidator", { enumerable: true, get: function () { return index_js_9.typeboxValidator; } });
// TODO: When previously tagged '@internal', these types could not be included in `InternalClassTreeTypes` due to https://github.com/microsoft/rushstack/issues/3639
var index_js_10 = require("./util/index.js");
Object.defineProperty(exports, "BrandedType", { enumerable: true, get: function () { return index_js_10.BrandedType; } });
Object.defineProperty(exports, "ErasedType", { enumerable: true, get: function () { return index_js_10.ErasedType; } });
var index_js_11 = require("./feature-libraries/index.js");
Object.defineProperty(exports, "flexTreeMarker", { enumerable: true, get: function () { return index_js_11.flexTreeMarker; } });
Object.defineProperty(exports, "FlexTreeEntityKind", { enumerable: true, get: function () { return index_js_11.FlexTreeEntityKind; } });
//# sourceMappingURL=index.js.map