"use strict";
/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.setField = exports.IterableTreeArrayContent = exports.TreeArrayNode = exports.TreeNode = exports.test_RecursiveObjectPojoMode = exports.test_RecursiveObject_base = exports.test_RecursiveObject = exports.typedObjectValues = exports.singletonSchema = exports.enumFromStrings = exports.adaptEnum = exports.getProxyForField = exports.SchemaFactoryRecursive = exports.toFlexConfig = exports.treeNodeApi = exports.getFlexNode = exports.SchemaFactory = exports.normalizeFieldSchema = exports.FieldSchema = exports.FieldKind = exports.type = exports.NodeKind = exports.TreeConfiguration = void 0;
var tree_js_1 = require("./tree.js");
Object.defineProperty(exports, "TreeConfiguration", { enumerable: true, get: function () { return tree_js_1.TreeConfiguration; } });
var schemaTypes_js_1 = require("./schemaTypes.js");
Object.defineProperty(exports, "NodeKind", { enumerable: true, get: function () { return schemaTypes_js_1.NodeKind; } });
Object.defineProperty(exports, "type", { enumerable: true, get: function () { return schemaTypes_js_1.type; } });
Object.defineProperty(exports, "FieldKind", { enumerable: true, get: function () { return schemaTypes_js_1.FieldKind; } });
Object.defineProperty(exports, "FieldSchema", { enumerable: true, get: function () { return schemaTypes_js_1.FieldSchema; } });
Object.defineProperty(exports, "normalizeFieldSchema", { enumerable: true, get: function () { return schemaTypes_js_1.normalizeFieldSchema; } });
var schemaFactory_js_1 = require("./schemaFactory.js");
Object.defineProperty(exports, "SchemaFactory", { enumerable: true, get: function () { return schemaFactory_js_1.SchemaFactory; } });
var proxyBinding_js_1 = require("./proxyBinding.js");
Object.defineProperty(exports, "getFlexNode", { enumerable: true, get: function () { return proxyBinding_js_1.getFlexNode; } });
var treeApi_js_1 = require("./treeApi.js");
Object.defineProperty(exports, "treeNodeApi", { enumerable: true, get: function () { return treeApi_js_1.treeNodeApi; } });
var toFlexSchema_js_1 = require("./toFlexSchema.js");
Object.defineProperty(exports, "toFlexConfig", { enumerable: true, get: function () { return toFlexSchema_js_1.toFlexConfig; } });
var schemaFactoryRecursive_js_1 = require("./schemaFactoryRecursive.js");
Object.defineProperty(exports, "SchemaFactoryRecursive", { enumerable: true, get: function () { return schemaFactoryRecursive_js_1.SchemaFactoryRecursive; } });
var proxies_js_1 = require("./proxies.js");
Object.defineProperty(exports, "getProxyForField", { enumerable: true, get: function () { return proxies_js_1.getProxyForField; } });
var schemaCreationUtilities_js_1 = require("./schemaCreationUtilities.js");
Object.defineProperty(exports, "adaptEnum", { enumerable: true, get: function () { return schemaCreationUtilities_js_1.adaptEnum; } });
Object.defineProperty(exports, "enumFromStrings", { enumerable: true, get: function () { return schemaCreationUtilities_js_1.enumFromStrings; } });
Object.defineProperty(exports, "singletonSchema", { enumerable: true, get: function () { return schemaCreationUtilities_js_1.singletonSchema; } });
Object.defineProperty(exports, "typedObjectValues", { enumerable: true, get: function () { return schemaCreationUtilities_js_1.typedObjectValues; } });
// Exporting the schema (RecursiveObject) to test that recursive types are working correctly.
// These are `@internal` so they can't be included in the `InternalClassTreeTypes` due to https://github.com/microsoft/rushstack/issues/3639
var testRecursiveDomain_js_1 = require("./testRecursiveDomain.js");
Object.defineProperty(exports, "test_RecursiveObject", { enumerable: true, get: function () { return testRecursiveDomain_js_1.RecursiveObject; } });
Object.defineProperty(exports, "test_RecursiveObject_base", { enumerable: true, get: function () { return testRecursiveDomain_js_1.base; } });
Object.defineProperty(exports, "test_RecursiveObjectPojoMode", { enumerable: true, get: function () { return testRecursiveDomain_js_1.RecursiveObjectPojoMode; } });
var types_js_1 = require("./types.js");
Object.defineProperty(exports, "TreeNode", { enumerable: true, get: function () { return types_js_1.TreeNode; } });
var arrayNode_js_1 = require("./arrayNode.js");
Object.defineProperty(exports, "TreeArrayNode", { enumerable: true, get: function () { return arrayNode_js_1.TreeArrayNode; } });
Object.defineProperty(exports, "IterableTreeArrayContent", { enumerable: true, get: function () { return arrayNode_js_1.IterableTreeArrayContent; } });
var objectNode_js_1 = require("./objectNode.js");
Object.defineProperty(exports, "setField", { enumerable: true, get: function () { return objectNode_js_1.setField; } });
//# sourceMappingURL=index.js.map