"use strict";
/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.brandOpaque = exports.extractFromOpaque = void 0;
/**
 * Converts a {@link Opaque} handle to the underlying branded type.
 *
 * It is assumed that only code that produces these "opaque" handles does this conversion,
 * allowing these handles to be considered opaque.
 * @internal
 */
function extractFromOpaque(value) {
    return value;
}
exports.extractFromOpaque = extractFromOpaque;
/**
 * Adds a type {@link Brand} to a value, returning it as a {@link Opaque} handle.
 *
 * Only do this when specifically allowed by the requirements of the type being converted to.
 * @internal
 */
function brandOpaque(value) {
    return value;
}
exports.brandOpaque = brandOpaque;
//# sourceMappingURL=opaque.js.map