/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import { ITreeCursor, ITreeCursorSynchronous } from "../../core/index.js";
import { JsonCompatible } from "../../util/index.js";
/**
 * Used to read a Jsonable tree for testing and benchmarking.
 *
 * @returns an {@link ITreeCursorSynchronous} for a single {@link JsonCompatible}.
 */
export declare function singleJsonCursor(root: JsonCompatible): ITreeCursorSynchronous;
/**
 * Extract a JS object tree from the contents of the given ITreeCursor.
 * Assumes that ITreeCursor contains only unaugmented JsonTypes.
 */
export declare function cursorToJsonObject(reader: ITreeCursor): JsonCompatible;
//# sourceMappingURL=jsonCursor.d.ts.map