/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import { ICodecOptions, IJsonCodec } from "../../../codec/index.js";
import { SchemaAndPolicy } from "../../../core/index.js";
import { JsonCompatibleReadOnly } from "../../../util/index.js";
import { TreeCompressionStrategy } from "../../treeCompressionUtils.js";
import { FieldBatch } from "./fieldBatch.js";
import { EncodedFieldBatch } from "./format.js";
export interface FieldBatchEncodingContext {
    readonly encodeType: TreeCompressionStrategy;
    readonly schema?: SchemaAndPolicy;
}
export type FieldBatchCodec = IJsonCodec<FieldBatch, EncodedFieldBatch, JsonCompatibleReadOnly, FieldBatchEncodingContext>;
export declare function makeFieldBatchCodec(options: ICodecOptions, writeVersion: number): FieldBatchCodec;
//# sourceMappingURL=codecs.d.ts.map