/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
export { TreeConfiguration } from "./tree.js";
export { NodeKind, type, FieldKind, FieldSchema, normalizeFieldSchema, } from "./schemaTypes.js";
export { SchemaFactory } from "./schemaFactory.js";
export { getFlexNode } from "./proxyBinding.js";
export { treeNodeApi } from "./treeApi.js";
export { toFlexConfig } from "./toFlexSchema.js";
export { SchemaFactoryRecursive } from "./schemaFactoryRecursive.js";
export { getProxyForField } from "./proxies.js";
export { adaptEnum, enumFromStrings, singletonSchema, typedObjectValues, } from "./schemaCreationUtilities.js";
// Exporting the schema (RecursiveObject) to test that recursive types are working correctly.
// These are `@internal` so they can't be included in the `InternalClassTreeTypes` due to https://github.com/microsoft/rushstack/issues/3639
export { RecursiveObject as test_RecursiveObject, base as test_RecursiveObject_base, RecursiveObjectPojoMode as test_RecursiveObjectPojoMode, } from "./testRecursiveDomain.js";
export { TreeNode } from "./types.js";
export { TreeArrayNode, IterableTreeArrayContent } from "./arrayNode.js";
export { setField, } from "./objectNode.js";
//# sourceMappingURL=index.js.map